package ru.landgrafhomyak.db.raw_sql_skeleton

import ru.landgrafhomyak.db.serdha0.api.misc.Column
import ru.landgrafhomyak.db.serdha0.api.table.Index
import ru.landgrafhomyak.db.serdha0.api.table.UniqueIndex

public interface TableConstructor<TableUserExtension : Any> {
	public fun createTable(context: Scope<TableUserExtension>): TableUserExtension

	public interface Scope<tUE : Any> {
		public fun column(name: String, type: String): Column<*, *, tUE>

		public fun index(name: String): Index<tUE>

		public fun uniqueIndex(name: String): UniqueIndex<tUE>
		public fun checkConstraint(name: String): CheckConstraint<tUE>
	}
}